         PRESERVE8 ; Indicate the code here preserve 
                   ; 8 byte stack alignment
         THUMB     ; Indicate THUMB code is used
         AREA    |.text|, CODE, READONLY   ; Start of CODE area

         EXPORT my_add_asm
my_add_asm FUNCTION
         ADDS    R0, R0, R1
         ADDS    R0, R0, R2
         ADDS    R0, R0, R3
         BX      LR  ; Return result in R0
         ENDFUNC
;---------------------------------------
         EXPORT call_c_from_asm_test
call_c_from_asm_test FUNCTION
        MOVS    R0, #0x1   ; First  parameter (x1)
        MOVS    R1, #0x2   ; Second parameter (x2)
        MOVS    R2, #0x3   ; Third  parameter (x3)
        MOVS    R3, #0x4   ; Fourth parameter (x4)
        IMPORT  my_add_c
        BL      my_add_c   ; Call "my_add_c" function. Result store in R0
        BX      LR
        ENDFUNC
;---------------------------------------
        EXPORT  CALC_SQUARE_Y
CALC_SQUARE_Y FUNCTION
        IMPORT  y
        LDR     R0,=y	   ; Obtain the address value of variable "y"
        LDR     R1, [R0]
        MULS    R1, R1, R1
        STR     R1, [R0]
        BX      LR
        ENDFUNC
;---------------------------------------
        ALIGN
        END
