
extern int my_add_asm(int x1, int x2, int x3, int x4);
extern int call_c_from_asm_test(void);
extern void CALC_SQUARE_Y(void);

volatile int y;  // define as volatile to prevent from optimized away

int main(void)
{
  y = my_add_asm(1, 2, 3, 4); // call the my_add_a function
  
  y = y * call_c_from_asm_test();

  CALC_SQUARE_Y();

  while (1);
}

int my_add_c(int x1, int x2, int x3, int x4)
{
  return (x1 + x2 + x3 + x4);
}

__asm void increment_y(void)
{
         LDR     R0,=__cpp(&y)
         LDR     R1, [R0]
         ADDS    R1, R1, #1  ; increment
         STR     R1, [R0]
         BX      LR  ; Return result in R0
		 ALIGN
}

__asm void embedded_asm_call_c(void)
{
         PUSH    {R4, LR}
         MOVS    R0, #0x1   ; First  parameter (x1)
         MOVS    R1, #0x2   ; Second parameter (x2)
         MOVS    R2, #0x3   ; Third  parameter (x3)
         MOVS    R3, #0x4   ; Fourth parameter (x4)
         BL      __cpp(my_add_c)

		 LDR     R4,=__cpp(my_add_c)
         MOVS    R0, #0x1   ; First  parameter (x1)
         MOVS    R1, #0x2   ; Second parameter (x2)
         MOVS    R2, #0x3   ; Third  parameter (x3)
         MOVS    R3, #0x4   ; Fourth parameter (x4)
         BLX     R4
         POP     {R4, PC}   ; Return
		 ALIGN
}

