    .text
    .syntax unified
    .thumb
    .type   HardFault_Handler, %function
    .global HardFault_Handler
    .global HardFault_Handler_c

HardFault_Handler:
    movs   r0, #4
    mov    r1, lr
    tst    r0, r1
    beq    hf_stacking_used_MSP
    mrs    r0, psp /* first parameter - stacking was using PSP */
    ldr    r1,=HardFault_Handler_c
    bx     r1
hf_stacking_used_MSP:
    mrs    r0, msp /* first parameter - stacking was using MSP */
    ldr    r1,=HardFault_Handler_c
    bx     r1
    .end
